/*
 * AppUser.java
 *
 * Created on September 7, 2006, 10:52 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.ergonosis.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import org.apache.commons.lang.StringUtils;

/**
 *
 * @author greg
 */
@Entity
@Table(name="app_user")
public class AppUser implements Serializable
{
  @Id
  @Column(name="username", nullable=false, unique=true)
  private String username;
  
  @ManyToMany
  @JoinTable(name = "user_role", joinColumns =  {@JoinColumn(name = "username", referencedColumnName = "username", unique=false)}, inverseJoinColumns = {@JoinColumn(name = "role_name", referencedColumnName = "name", unique=false)})
  private List<Role> roles = new ArrayList<Role>();
  
  /**
   * Creates a new instance of AppUser
   */
  public AppUser()
  {
  }
  
  public int hashCode()
  {
    int hash = 0;
    hash += (this.getUsername() != null ? this.getUsername().hashCode() : 0);
    return hash;
  }
  
  public boolean equals(Object object)
  {
    // TODO: Warning - this method won't work in the case the id fields are not set
    if (!(object instanceof AppUser))
    {
      return false;
    }
    AppUser other = (AppUser)object;
    if (this.getUsername() != other.getUsername() && (this.getUsername() == null || !this.getUsername().equals(other.getUsername()))) return false;
    return true;
  }
  
  public String toString()
  {
    return getUsername();
  }
  
  public String getUsername()
  {
    return username;
  }
  
  public void setUsername(String username)
  {
    this.username = username;
  }
  
  public List<Role> getRoles()
  {
    return roles;
  }
  
  public void setRoles(List<Role> roles)
  {
    this.roles = roles;
  }
}
